#ifndef ABSTRACTELEMENTDEFINITION_SEEN
#define ABSTRACTELEMENTDEFINITION_SEEN

#include <iostream>
#include <sstream>
#include <string>

#include "mathematicalTools.h"
#include "nomdElements.h"

using namespace std;


class abstractElement
{

 protected:

  bool parmelaOk_;
  bool transportOk_;

  int nbParam_;
  string* parametersString_;



  //  double phaseStep_; // a recuperer dans les parametres globaux (methode setPhaseStep)
  double phaseStepMax_;

  double defaultLength_;
  double defaultAperture_;



  string label_;
  nomdElement elementName_;
  double lenghtElem_; // cm
  double aperture_; // cm

  double stepmaxcm_;
  //  bool curvedTrajectory_;

  void setDefaultValues() 
  {
    label_ = "";
    nbParam_ = 2;
      defaultLength_ = 0.0;
      defaultAperture_ = 1.e+6;
    phaseStepMax_ = 10.;
  }


  void setDefaults() 
  {
    lenghtElem_ = defaultLength_;
    aperture_ = defaultAperture_;
    parmelaOk_ = false;
    transportOk_ = false;
  }

 public :


 abstractElement() 
    {
      label_ = string("");
      setDefaultValues();
      setDefaults();
      stepmaxcm_ = 1000000;
      //      curvedTrajectory_ = false;
    }


  abstractElement(string lab)
    {
      label_ = lab;
      setDefaultValues();
      setDefaults();
      stepmaxcm_ = 1000000;
      //      curvedTrajectory_ = false;
    }

virtual  ~abstractElement() {if (parametersString_ != NULL) delete [] parametersString_ ;}

 virtual void setPhaseStep(double ) { cout << " setPhaseStep : ce n'est pas celui la qu'il faut ! " ; return;}


 void setParameters(double ll, double aper) 
  {
    lenghtElem_ = ll;
    aperture_ = aper;
  }

 virtual void setParametersString(string* param)  = 0;

string getLabel() const
{
  return label_;
}


  nomdElement getName() const 
  {
    return  elementName_;
  }


 double getLenghtOfElement() const { return lenghtElem_;}

 int getNbParams() const {return nbParam_;};

 bool is_parmela_element() const {return parmelaOk_;};
 bool is_transport_element() const {return transportOk_;};

 virtual string* getParametersString() const = 0;


 virtual string parmelaOutputFlow() const =0;
 virtual string transportOutputFlow() const =0;


 virtual double getInitialKineticEnergy() const {return 0.0;}


 virtual string FileOutputFlow() const=0;
 virtual void FileInput(ifstream& ifs) = 0;

};



#endif
