#include "dataManager.h"
#include "environmentVariables.h"

#include <stdio.h>
#include <fstream>

//using namespace std;

abstractElement* dataManager::addElement(nomdElement elemType)
{
  return elementsGallery_.addElement(elemType);
}




  // void dataManager::addSectionToExecute(int debut, int fin, nomDeLogiciel prog)
  // {
  //   jobList_.push_back(new sectionToExecute);
  //   jobList_.back()->firstElement = debut;
  //   jobList_.back()->lastElement = fin;
  //   jobList_.back()->software  = prog;
  // }

// void dataManager::clearSectionToExecute()
// {
//   unsigned k;
//   for (k=0; k < jobList_.size();k++)
//     {
//       if ( jobList_[k] != NULL ) delete jobList_[k];
//     }
//   jobList_.clear();
// }


string dataManager::executeTransport( unsigned int indexDeb, unsigned int indexFin)
{
    ostringstream sortie;

  sortie << " EXECUTION DE TRANSPORT DE " << indexDeb << " a " << indexFin << endl;
  //  sortie << " (programmation en cours) " << endl;
  createInputFileTransport( indexDeb, indexFin);

  string buf;
  string transportJob = WORKINGAREA + "/transport";
  transportJob += string(" <  ");
  transportJob += WORKINGAREA + "/transport.input";
  transportJob += string(" >  ");
  transportJob += WORKINGAREA + "/transport.output";
  cout << " job transport= " << transportJob << endl;

  FILE* pp = popen(transportJob.c_str(), "r");
  if (pp == NULL)
    {
      cerr << " execution transport foire " << endl;
      return string("");
    }
  else
    {
      cout << " execution transport MARCHE " << endl;

     ifstream infile;
     string name = WORKINGAREA + "/transport.output";
      infile.open(name.c_str(), ios::in);
      if (!infile) 
	{
	  cerr << " error opening transport output stream " << name << endl;
	}



      unsigned nbl = 0;
      while (getline(infile, buf) )
	{
	  sortie << buf << endl;
	  //	  cout << " buf: " << buf << endl;
	  nbl++;
	}
      infile.close();
      infile.clear();
      infile.open(name.c_str(), ios::in);
      if (!infile) 
	{
	  cerr << " error re-opening transport output stream " << name << endl;
	}
      else
	{
	  cout << " successfull re-opening transport output stream " << name << endl;
	}


      //         cout << " sortie transport " << sortie.str() << endl;

      // nbl = 0;
      // //      while (getline(infile, buf) )
      // for ( int ibid= 0; ibid < 80; ibid++)
      // 	{
      // 	  getline(infile, buf);
      // 	  cout << " buf deux fois : " << buf << endl;
      // 	  nbl++;
      // 	}


      currentBeam_.setFromTransport(infile, nbl);

      infile.close();
      pclose(pp);
      return sortie.str();
    }
      return sortie.str();
}


string dataManager::executeParmela( unsigned int indexDeb, unsigned int indexFin)
{

  createInputFileParmela(indexDeb, indexFin);

  ostringstream sortie;
  sortie << " EXECUTION DE PARMELA DE l'ELEMENT " << indexDeb << " A L'ELEMENT " << indexFin << endl;

  char buf[132];
  string parmelaJob = WORKINGAREA + "/parmela";
  parmelaJob += string("   ");
  parmelaJob += WORKINGAREA;
  cout << " job parmela= " << parmelaJob << endl;
  FILE* pp = popen(parmelaJob.c_str(), "r");
  if (pp == NULL)
    {
      cerr << " execution parmela foire " << endl;
      return string("");
    }
  else
    {
      cout << " execution parmela MARCHE " << endl;
      while (fgets(buf, sizeof buf, pp))
	{
	  sortie << buf;
	}

      //      cout << " sortie parmela " << sortie.str() << endl;

      currentBeam_.setFromParmela(globParam_.getFrequency());
      pclose(pp);
      return sortie.str();
    }
  
}


void dataManager::createInputFileTransport( unsigned int indexDeb, unsigned int indexFin)
{
  unsigned int k;
  if ( !currentBeam_.momentRepresentationOk() )
    {

	  cerr << " dataManager::createInputFileTransport : the beam is not OK " << endl;
    }
  indexDeb--;
  indexFin--;

  const vector< vector<double> >& moments = currentBeam_.getTransportMoments();
  double P0 = currentBeam_.getP0Transport();
  ofstream outfile;
  string name = WORKINGAREA + "/transport.input";
  outfile.open(name.c_str(), ios::out);
  if (!outfile) 
    {
      cerr << " error opening output stream " << name << endl;
    }

  outfile << string("'titre provisoire'") << endl;
  outfile << " 0 " << endl;
  outfile << " UTRANS " << endl;

  outfile << " BEAM, X=" << (moments.at(0)).at(0) << ", XP="<< (moments.at(1)).at(1) << ", Y=" << (moments.at(2)).at(2)<< ", YP=" << (moments.at(3)).at(3) << ", & " << endl;

  outfile << " DL=" << (moments.at(4)).at(4) << ", DEL="<< (moments.at(5)).at(5) << ", P0=" << P0 << " ; " << endl;

  outfile << " CORR, C21=" << (moments.at(1)).at(0) << ", C31="<< (moments.at(2)).at(0) << ", C32=" << (moments.at(2)).at(1) << ", & " << endl;

  outfile << " C41=" << (moments.at(3)).at(0) << ", C42="<< (moments.at(3)).at(1) << ", C43=" << (moments.at(3)).at(2) << ", C51=" << (moments.at(4)).at(0) << ", & " << endl;

  outfile << " C52=" << (moments.at(4)).at(1) << ", C53="<< (moments.at(4)).at(2) << ", C54=" << (moments.at(4)).at(3) << ", C61=" << (moments.at(5)).at(0) << ", & " << endl;

  outfile << " C62=" << (moments.at(5)).at(1) << ", C63="<< (moments.at(5)).at(2) << ", C64=" << (moments.at(5)).at(3) << ", C65=" << (moments.at(5)).at(4) << " ; " << endl;
  outfile << " PRINT, BEAM, ON; " << endl;


  abstractElement* elPtr;
  for ( k=indexDeb; k <= indexFin; k++)
    {
      elPtr = elementsGallery_.getElementPointer(k);
      outfile << elPtr->transportOutputFlow() << endl;
    }

  outfile << " SENTINEL " << endl;
  outfile << " SENTINEL " << endl;

  outfile.close();

}

void dataManager::createInputFileParmela( unsigned int indexDeb, unsigned int indexFin)
{
  indexDeb--;
  indexFin--;

 


  ofstream outfile;
  string name = WORKINGAREA + "/parmin";
  outfile.open(name.c_str(), ios::out);
      if (!outfile) 
	{
	  cerr << " error opening output stream " << name << endl;
	}
  unsigned int k;
  abstractElement* elPtr;

  elPtr = elementsGallery_.getElementPointer(indexDeb);
  if ( elPtr->getName() != initialBeam ) 
    {
      cerr << " dataManager::createInputFileParmela : the first element should be initialBeam" << endl;
    }
  

  double initalKineticEnergy = 0.0;
  for ( k=indexDeb; k <= indexFin; k++)
    {
      if ( elPtr->getName() == initialBeam ) 
	{
	  elPtr->setPhaseStep( globParam_.getIntegrationStep() );
	  elPtr = elementsGallery_.getElementPointer(k);
	  initalKineticEnergy = elPtr->getInitialKineticEnergy();
	  break;
	}
    }

  outfile << "TITLE" << endl;
  outfile << " titre provisoire " << endl;
  outfile << "RUN /n0=1 /ip=999 /freq=" << globParam_.getFrequency() << "  /z0=0.0 /W0=" << initalKineticEnergy << "  /itype=1" << endl;
  outfile << "OUTPUT 0" << endl;
    
  for ( k=indexDeb; k <= indexFin; k++)
    {
      elPtr = elementsGallery_.getElementPointer(k);
      outfile << elPtr->parmelaOutputFlow() << endl;
    }
  outfile << "ZOUT" << endl;
  outfile << "START /wt=0.0 /dwt=" << globParam_.getIntegrationStep() << "  /nsteps=" << globParam_.getNbSteps() << "  nsc=" << globParam_.getScPeriod() << "  /nout=10" << endl;
  outfile << "END" << endl;
  outfile.close();
}

void dataManager::initializeExecution()
{
  ifstream testParmdesz;
  string parmdesz = WORKINGAREA + "/parmdesz";
  testParmdesz.open(parmdesz.c_str(), ios::in);
  if (testParmdesz)
    {
      testParmdesz.close();
      remove(parmdesz.c_str());
    }
  currentBeam_.clear();
}

  // string dataManager::executeAll()
  // {
  //   //    return executeParmela( 0, elementsGallery_.size()-1);
  //   unsigned k;
  //   int debut, fin;
  //   currentBeam_.clear();
  //   string resul("");
  //   for ( k=0; k< jobList_.size(); k++)
  //     {
  // 	debut = jobList_[k]->firstElement;
  // 	fin = jobList_[k]->lastElement;
  // 	if ( jobList_[k]->software == nomDeLogiciel::parmela ) resul += executeParmela( debut, fin);
  // 	else if ( jobList_[k]->software == nomDeLogiciel::transport ) resul += executeTransport( debut, fin);
  // 	else 
  // 	  {
  // 	    resul +=  " unknown software -- STOP \n ";	
  // 	    break;
  // 	  }
  //     }
  //   //    cout << " resultat : " << resul << endl;
  //   return resul;
  // }



  void dataManager::saveAll()
  {
     ofstream outfile;
     string name = WORKINGAREA + "/pspa.save";
  outfile.open(name.c_str(), ios::out);
      if (!outfile) 
	{
	  cerr << " error opening output file for persistency " << name << endl;
	}
  outfile << globParam_.FileOutputFlow();
  int k;
  abstractElement* elPtr;
  for ( k=0 ; k < elementsGallery_.size() ; k++)
    {
      elPtr = elementsGallery_.getElementPointer(k);
      outfile << elPtr->FileOutputFlow();
    }
    outfile.close();    
  }

  void dataManager::restoreAll()
  {
     ifstream infile;
     string name = WORKINGAREA + "/pspa.save";
      infile.open(name.c_str(), ios::in);
      if (!infile) 
	{
	  cerr << " error opening input stream " << name << endl;
	}
      int ielem;

      string globalTitle;
      if ( infile >> globalTitle )
	{
	  if ( globalTitle == string("globals") ) 
	    {
	      globParam_.raz();
	      globParam_.FileInput(infile);
	    }
	  else
	    {
	      cerr << " dataManager::restoreAll ERROR : global parameters seems to be missing" << endl;
	    }
	}
      else
	{
	  cerr << " dataManager::restoreAll ERROR : reading data save file" << endl;
	}
      elementsGallery_.raz();
      nomdElement elem;
       while (infile >> ielem)
       	{
	  elem = (nomdElement)ielem;
       	  abstractElement* nouveau = addElement(elem);
       	  nouveau->FileInput(infile);
       	}


      infile.close();
  }
